unit seznam_u;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type
  T = integer;

const
  NULA = 0;


type
  uprvek = ^prvek;

  prvek = object
     private
       FData: T;
       FDalsi: uprvek;
       class var
          FPocetPrvku: integer;
     public
       constructor Init(_data: T; _dalsi: uprvek);
       property Data: T read FData write FData;
       property Dalsi: uprvek read FDalsi write FDalsi;
       class function Pocet: integer;
       class property PocetPrvku: integer read FPocetPrvku;
  end;

  useznam = ^seznam;

  seznam = object
    private
      FHlava, FZarazka: uprvek;
      FVelikost: integer;
    public
      constructor Init;
      destructor Done;
      property Velikost: integer read FVelikost;
      procedure VlozNaZacatek(co: T);
      procedure Vypis;
      procedure OdstranPrvni;
      procedure Vyprazdni;
      function prazdny: Boolean;
  end;

implementation

// Metody prvku

constructor Prvek.Init(_data: T; _dalsi: uprvek);
begin
  Data := _data;
  Dalsi := _dalsi;
  inc(FPocetPrvku);
end;

class function Prvek.Pocet: integer;
begin
   result := FPocetPrvku;
end;

//---------------------------------------------
// Metody seznamu

constructor seznam.Init;
begin
   FHlava := new(uprvek, Init(NULA, nil));
   FZarazka := FHlava;
   FVelikost := 0;
end;

destructor seznam.Done;
begin
   Vyprazdni;
   dispose(FHlava);
end;

procedure seznam.VlozNaZacatek(co: T);
begin
   FHlava:=new(uprvek, Init(co, FHlava));
   FVelikost := FVelikost + 1;
end;

procedure seznam.Vypis;
var
  aktualni: uprvek;
begin
  write('{');
  aktualni := FHlava;
  while aktualni <> FZarazka do
  begin
     write(aktualni^.Data, ' ');
     aktualni:= aktualni^.Dalsi;
  end;
  write('}');
end;

procedure seznam.OdstranPrvni;
var
  pomoc: uprvek;
begin
  if not prazdny then
  begin
     pomoc := FHlava;
     FHlava:=FHlava^.Dalsi;
     dispose(pomoc);
     dec(FVelikost);
  end;
end;

function seznam.prazdny: Boolean;
begin
  Result := (FHlava = FZarazka);
end;

procedure seznam.Vyprazdni;
begin
  while not prazdny do
  begin
     OdstranPrvni;
  end;
end;

end.

