unit seznam_u;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type
  T = integer;

const NULA = 0;

type
  TPrvek = class
    private
      FData: T;
      FDalsi: TPrvek;
      class var
         FPocet: integer;
    public
      constructor Create(_data: T; _dalsi: TPrvek);
      property Data: T read FData write FData;
      property Dalsi: TPrvek read FDalsi write FDalsi;
      class function pocet: integer;
  end;

type
  TSeznam = class
    private
      FHlava, FZarazka: TPrvek;
      FVelikost: Integer;
    public
      constructor Create;
      destructor Destroy; override;
      procedure VlozNaZacatek(co: T);
      procedure Vypis;
      procedure OdstranPrvni;
      function Prazdny: Boolean;
      procedure Vyprazdni;
  end;

implementation

constructor TPrvek.Create(_data: T; _dalsi: TPrvek);
begin
  Data := _data;
  Dalsi := _dalsi;
end;

class function TPrvek.pocet: integer;
begin
   result := FPocet;
end;

// -----------------------------------

constructor TSeznam.Create;
begin
  FHlava := TPrvek.Create(NULA, nil);
  FZarazka := FHlava;
  FVelikost := 0;
end;

destructor TSeznam.Destroy;
begin
  Vyprazdni;
  FHlava.Free;
  writeln('destruktor');
end;

procedure TSeznam.VlozNaZacatek(co: T);
begin
   FHlava := TPrvek.Create(co, FHlava);
end;

procedure TSeznam.Vypis;
var pom: TPrvek;
begin
   pom := FHlava;
   write('{');
   while pom <> FZarazka do
   begin
      write(pom.Data, ' ');
      pom := pom.Dalsi;
   end;
   write('}');
end;

function TSeznam.Prazdny: Boolean;
begin
   Result := (FHlava = FZarazka);
end;

procedure TSeznam.OdstranPrvni;
var pom: TPrvek;
begin
   if not Prazdny then
   begin
     pom := FHlava;
     FHlava := FHlava.Dalsi;
     pom.Free;
   end;
end;

procedure TSeznam.Vyprazdni;
begin
  while not Prazdny do
  begin
     OdstranPrvni;
  end;
end;

end.

